<template>
  <v-ons-page>
    <v-ons-toolbar>
      <div class="left">
        <v-ons-icon
          icon="ion-ios-arrow-back"
          size="lg"
          @click="redirect(previousUrl, {tab: 'setting'})"
        ></v-ons-icon>
      </div>
      <div class="center">Network Setting</div>
      <div class="right">
        <v-ons-toolbar-button icon="ion-navicon"></v-ons-toolbar-button>
      </div>
    </v-ons-toolbar>

    <div class="network-container">
      <p v-if="seedNode">
        Current Seed Node IP:
        <strong>{{ seedNode.ip }}</strong>
      </p>
      <p v-else>Current Seed Node IP:</p>

      <p v-if="seedNode">
        Current Seed Node PORT:
        <strong>{{ seedNode.port }}</strong>
      </p>
      <p v-else>Current Seed Node PORT:</p>

      <form class="network-form" v-on:submit.prevent="onUpdateSeedNode">
        <div>
          <label for>Seed node ip:</label>
          <input type="text" placeholder="New ip address" v-model="newIP" class="network-input" />
        </div>
        <div>
          <label for>Seed node port:</label>
          <input type="text" placeholder="New port number" v-model="newPort" class="network-input" />
        </div>
        <v-ons-button class="default-btn" type="submit" @click="onUpdateSeedNode">Update Network</v-ons-button>
      </form>
      <v-ons-button
        class="new-message-btn"
        modifier="quiet"
        @click="onResetNetwork"
      >Reset to Default Network</v-ons-button>
    </div>
  </v-ons-page>
</template>

<script>
import Vue from "vue";
import "onsenui/css/onsenui.css";
import "onsenui/css/onsen-css-components.css";
import VueOnsen from "vue-onsenui/esm";
import OnsenComponents from "~/components/Onsen";
import ChatText from "~/components/ChatText";
import ChatInput from "~/components/ChatInput";
import { mapGetters, mapActions } from "vuex";
import CONFIG from "../../config";
import utils from "../../assets/utils";

Vue.use(VueOnsen);
Object.values(OnsenComponents).forEach(c => Vue.component(c.name, c));

export default {
  data: function() {
    return {
      newPort: "",
      previousUrl: "/",
      newIP: "",
      seedNode: CONFIG.server
    };
  },
  computed: {
    ...mapGetters({
      getNetwork: "chat/getNetwork"
    })
  },
  beforeRouteEnter(to, from, next) {
    next(vm => {
      vm.previousUrl = from.path;
      console.log(vm.previousUrl);
    });
  },
  methods: {
    ...mapActions({
      updateNetwork: "chat/updateNetwork"
    }),
    redirect(url, option) {
      console.log(`Pushing to ${url}`);
      this.$router.push(url);
      if (url === "/" && option) {
      }
    },
    onUpdateSeedNode() {
      console.log("Updating Seednode and network");
      utils.updateSeedNodeHost(this.newIP, this.newPort);
      this.seedNode = {
        ip: this.newIP,
        port: this.newPort
      };
      this.updateChatServerHost();
      this.newIP = "";
      this.newPort = "";
    },
    async updateChatServerHost() {
      console.log("Updating chat server host...");
      let randomHost = await utils.getRandomHost();
      this.updateNetwork(randomHost);
      utils.updateHost(`${randomHost.ip}:${randomHost.port}`);
    },
    async onResetNetwork() {
      console.log("Resetting Seednode and network");
      utils.updateSeedNodeHost(CONFIG.server.ip, CONFIG.server.port);
      this.seedNode = CONFIG.server;
      this.updateChatServerHost();
      this.newIP = "";
      this.newPort = "";
    }
  }
};
</script>

<style>
.import-account-container {
  text-align: center;
  margin-top: 30px;
}
.secret-key-input {
  margin-right: 5px;
}
.qr-code-btn {
  height: 40px;
  padding: 5px;
}
.secret-input-container {
  display: flex;
  justify-content: center;
  align-items: center;
}
#secret-key {
  font-size: 16px;
  width: 80%;
  margin: 20px auto;
  max-width: 420px;
  color: #2287af;
  letter-spacing: -0.18px;
  text-align: center;
  line-height: 27px;
  margin: 20px auto;
  text-transform: uppercase;
  user-select: text;
}
.network-container {
  width: 80%;
  max-width: 300px;
  margin: 20px auto;
  text-align: center;
}
.network-container p {
  text-align: left;
  margin-bottom: 10px;
}
.network-form {
  border-top: 1px solid #d9d9d9;
  margin-top: 15px;
  padding-top: 15px;
}
.network-form div {
  text-align: left;
}
.network-form label {
  font-size: 12px;
  text-align: left;
}
.network-form .network-input {
  height: 40px;
  width: 100%;
  padding: 5px 10px;
  background: #fff;
  border: 1px solid #dddddd;
  border-radius: 5px;
  margin: 20px auto;
  margin-top: 5px;
}
</style>
